

const CAT_PURE_TEXT       = 1;
const CAT_NAVIGATION_MENU = 2;
const CAT_HEADER          = 3;
const CAT_TEXT_WITH_LINKS = 4;

const NAV_ANCHOR_RATIO    = 0.6;
const NAV_ANCHOR_NUMBER   = 2;

function getElementsWithAttribute(rootNode,attName,attValue,deep){

	var resultNodes = new Array();

	if(rootNode.childNodes){
            

		for(var i = 0; i < rootNode.childNodes.length; i++){

			var curNode = rootNode.childNodes[i];

			

			if((curNode.getAttribute && attName!='class' && curNode.getAttribute(attName) == attValue)

			|| (attName == 'class' && curNode.className == attValue)

			)

				resultNodes.push(curNode);

				

			if(deep){

				var deepFound = getElementsWithAttribute(curNode,attName,attValue,deep);

				for(var j = 0; j < deepFound.length; j++){

					resultNodes.push(deepFound[j]);

				}

			}

			

		}

	}

	return resultNodes;

}

function RAY_getElementsWhichSatisfies( rootNode, predicate ) {
    
    var resultNodes = new Array();

	if(rootNode.childNodes){
            

		for(var i = 0; i < rootNode.childNodes.length; i++){

			var curNode = rootNode.childNodes[i];
                        
                        if ( predicate( curNode ) ) {
                            
                            resultNodes.push(curNode);
                            
                        }
                        
                        var deepFound = RAY_getElementsWhichSatisfies(curNode,predicate);

                        for(var j = 0; j < deepFound.length; j++){

                                resultNodes.push(deepFound[j]);

                        }
                        
                }
                
        }
                
    return resultNodes;
    
}



function RAY_isNavigationMenu( element ) {
    
    var result = false;
    
    var elementTextLength = RAY_getInnerText(element).trim().length;
    
    var childAnchors = element.getElementsByTagName('A');
  
    var anchorTextLength = 0;
    
    if ( childAnchors.length > 0 ) {
        
        for( var i = 0; i<childAnchors.length; i++ ) {
            
           anchorTextLength += RAY_getInnerText( childAnchors[i] ).trim().length;
            
        }
        
        result = ( ( anchorTextLength / elementTextLength ) > NAV_ANCHOR_RATIO ) &&
                 ( childAnchors.length > NAV_ANCHOR_NUMBER );
        
    }
    
    return   result;
    
}

function RAY_isTextBlock( element ) {
    
    
    
}

var imagesToAltRegExp = /<img.*alt=['"](.*)['"].*>/gi;
var strippingRegExp = /<\/?[^>]+>/gi;
var multispaceRegExp = /\s{2,}/gi;

function RAY_getInnerText(element){
  
  xStr = element.innerHTML;  
    
  xStr = xStr.replace(imagesToAltRegExp,"$1").replace(strippingRegExp,"").replace(multispaceRegExp," ");
  
  return xStr;

}


      