
/* parametri */

var lengthP = 40.0;

var headerFactor = 4;


function rgbColor(r,g,b) {
	this.r = r;
	this.g = g;
	this.b = b;
}

function rgbColor_getLuminance() {
	with (this)
		return (r / 255) * 0.2126 + (g / 255) * 0.7152 + (b / 255) * 0.0722;
}

rgbColor.prototype.getLuminance = rgbColor_getLuminance;

function getStyleProp(element, prop) {
	
	var result;
	
	if ( element ) {
		
		result = RAY_currentDocument.defaultView.getComputedStyle(element, null).getPropertyValue(prop);
	
	} else {
		
		result = null;
	}
	
	return result;
}

function getFGcolor(element) {
	
	var fg = getStyleProp(element, 'color');
	var re = /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/;
	var matches = re.exec(fg);

	return new rgbColor(matches[1],matches[2],matches[3]);
	
}

function getBGcolor(element) {
	
	current = element;
	
	while( ((bg = getStyleProp(current, 'background-color')) == 'transparent') &&
			(current.tagName.toLowerCase() != 'body') 
			) {
			current = current.parentNode;
	}
	
	if (bg == 'transparent') {
		bgColor = new rgbColor(255,255,255);
	} else {
		var re = /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/;
		var matches = re.exec(bg);
		//alert( '-'+bg+'-' );
		bgColor = new rgbColor(matches[1],matches[2],matches[3]);
	}

	return bgColor;
	
}

function getContrast( element ) {

	fgColor = getFGcolor(element);
	bgColor = getBGcolor(element);

	return Math.abs( fgColor.getLuminance()-bgColor.getLuminance() );

}

function isHeader( element ) {

	var res = false;
	
	if (element.tagName) {
		
		res = headerElements.indexOf( element.tagName ) != -1;
		
	}
	
	if ( !res ) {
		
		var elFontSize = getFontSize( element );
		
		var bodyFontSize = getFontSize( RAY_currentDocument.getElementsByTagName('BODY')[0] );
				
		res = elFontSize-bodyFontSize > headerFactor;
		
	}
	
	
	return res;
	
}


function getHeaderLevel(element) {

	var result = 0;
	
	tName = element.tagName;

	if (tName.substr(0,1).toLowerCase() == 'h') {
		result = 1/6 * (7-tName.substr(1,1));
	}	
	
	return result;

}

function getLengthFactor(element) {

	elLength = element.textContent.length;
	
	return 1/(elLength/lengthP +1);
	
}


function getImportance(element) {
	// getContrast(element) + getHeaderLevel(element) +
	//alert( element.tagName );
	//return   getLengthFactor(element);
	
	//return 100/getDensity(element)+getHeaderLevel(element)+getContrast(element);
	
	return getFontSize( element );
	
}

function getFontSize(element) {
	
	var el;
	
	if ( (el = RAY_getNextValidSibling(element)) == null ) {
		
		el = element;
		
	}
	
	var sizeStr = getStyleProp( el, 'font-size' );
	
	if ( sizeStr != null ) {
	
		// assuming px size is returned
		var pPos = sizeStr.indexOf( 'p' );
		
		return sizeStr.substring(0,pPos);
		
	} else {
		
		return 0;
		
	}
	
}

function getDensity(element) {

	surface = parseInt(getStyleProp(element, 'width')) * parseInt(getStyleProp(element, 'height'));

	return (surface / element.textContent.length);

}



//document.onmousedown=function(e) { var element = e.target?e.target:e.srcElement; alert( getImportance(element))};












